<!--- Macromedia ColdFusion(r) 5.0 - Code Examples --->
<!--- CFGRID Example --->
<cfset pagename="CFGRID Example">
<cfinclude template="../header.cfm">
<cfinclude template="../behindscenes.cfm">
<cfinclude template="../margintop.cfm">

<p>
ColdFusion 5 introduces new cfform components implemented with the JDK 1.2 and run as clients of the Sun Java Plug-In in the browser.  Try some of these new features of cfgrid:
<ul>
	<li>Columns can be re-arranged via dragging and dropping
	<li>The grid can be sorted by column by double clicking on the grid header 
	<li>Check boxes and drop-down lists may be used for cell editing (try the "department" column)
	<li>Expressions can be used in attributes, for example <br>
	<font face="Courier New">TextColor = "(CX GT 500 ? red : black )"</font>
	<br>means that if the value of the cell is greater than 500, the text in the cell will be displayed red. Otherwise, it will be displayed black. 
</ul> 
<table width="644" cellspacing="0" cellpadding="0" border="0">
	<tr>
		<td width="485" valign="top" colspan="2">
		
		<table border="0" cellpadding="4">
			<tr>
				<td>
											
				<!--- If the UpdateCourses form field has been tripped,
				perform the gridupdate on the table specified in the database.
				Using the default value keyonly = yes allows us to change only
				the information that differs from the previous grid --->
				<cfif IsDefined("form.UpdateCourses") is True>
					<cfgridupdate grid="CourseGrid" 
						dataSource="cfsnippets"
						tableName="CourseList"
						keyOnly="Yes">
				</cfif>
	
				<!--- retrieve all departments --->
				<cfquery name="qDepartments" dataSource="cfsnippets">
				SELECT Dept_ID
				FROM  Departments
				ORDER by Dept_ID ASC
				</cfquery>
				
				<!--- convert department id records to a list for cfgridcolumn values 
					attribute to create a select list options --->
				<cfset lDepartments = ValueList(qDepartments.Dept_ID)>
				
				<!--- query the database for course grid values --->
				<cfquery name="qCourses" dataSource="cfsnippets">
				SELECT Course_ID, Dept_ID, CorNumber, CorName, CorLevel
				FROM  CourseList
				ORDER by Dept_ID ASC, CorNumber ASC
				</cfquery>
				
				<cfoutput>
				
				<!--- create the grid and columns within a cfform tagset --->
				<cfform name="Courses" action="index.cfm" method="POST">
				
				<cfgrid name="CourseGrid"
					width="401"
					height="350"
					query="qCourses"
					insert="Yes"
					delete="Yes"
					font="Tahoma"
					bold="No"
					italic="No"
					appendKey="No"
					highlightHref="No" 
					gridDataAlign="LEFT"
					gridLines="Yes"
					rowHeaders="Yes"
					rowHeaderAlign="CENTER" 
					rowHeaderItalic="No"
					rowHeaderBold="No" 
					colHeaders="Yes"
					colHeaderAlign="LEFT"
					colHeaderItalic="No"
					colHeaderBold="No" 
					selectColor="Red"
					selectmode="edit"
					insertbutton="InsertMe"
					sort="yes"
					sortascendingbutton="AscendMe"
					sortdescendingbutton="DescendMe"		
					picturebar="yes"
					>
					
					<cfgridcolumn name="Course_ID"
			        headeralign="LEFT"
			        dataalign="LEFT"
			        bold="No"
			        italic="No"
			        select="No"
			        display="No"
			        headerbold="No"
			        headeritalic="No">

					<!--- Note in the following column, that providing the 
					values and valuesDisplay lists makes the inputs for 
					this column drop-down lists and selects the current 
					value. --->
					<cfgridcolumn name="Dept_ID"
			        header="Department"
			        headeralign="LEFT"
			        dataalign="LEFT"
			        width="80"
			        bold="Yes"
			        italic="No"
			        select="Yes"
			        display="Yes"
			        headerbold="No"
			        headeritalic="No"
			        values="#lDepartments#"
			        valuesdisplay="#qCourses.Dept_ID#">
									
					<cfgridcolumn name="CorNumber"
			        header="Course ##"
			        headeralign="LEFT"
			        dataalign="LEFT"
			        width="60"
			        bold="No"
			        italic="No"
			        select="Yes"
			        display="Yes"
			        type="NUMERIC"
			        headerbold="No"
			        headeritalic="No"
					TextColor = "(CX GT 500 ? red : black )">

					<cfgridcolumn name="CorName"
			        header="Name"
			        headeralign="LEFT"
			        dataalign="LEFT"
			        width="120"
			        font="Times"
			        bold="No"
			        italic="No"
			        select="Yes"
			        display="Yes"
			        type="STRING_NOCASE"
			        headerbold="No"
			        headeritalic="No">
			
					<cfgridcolumn name="CorLevel"
			        header="Level"
			        headeralign="LEFT"
			        dataalign="LEFT"
			        width="80"
			        bold="No"
			        italic="No"
			        select="Yes"
			        display="Yes"
			        headerbold="No"
			        headeritalic="No"
			        values="Basic, Intermediate, Advanced"
			        valuesdisplay="#qCourses.CorLevel#">
				</cfgrid>
				<br>
				<br>
				<br>
				<input type="Submit" name="UpdateCourses" value="Apply Changes">
				
				</cfform>

				</cfoutput>
				</td>
			</tr>
		</table>	
		
		</td>
	</tr>
</table>
	
<br><br>
<cfinclude template="../marginbottom.cfm">
<cfinclude template="../behindscenes.cfm">
<cfinclude template="../footer.cfm">

