<!--- Macromedia ColdFusion(r) 5.0 - Code Examples --->
<!--- Data Drill-Down Example --->
<cfset pagename="Data Drill-Down Example">
<cfinclude template="../header.cfm">
<cfinclude template="../behindscenes.cfm">
<cfinclude template="../margintop.cfm">

<p>
<!---
	This query uses dynamic SQL to construct a query that 
	fits what information was sent from the previous form (index.cfm).
	You can see that the SQL conditions are added to the SQL
	if a search field was entered. Notice that CFQUERYPARAM is used
	to format the ItemName variable.  This provides extra protection
	to assure that the correct type of data is passed via the form
	field.
--->
<cfparam name="FORM.CategoryID" default="">
<cfparam name="FORM.ItemName" default="">

<cfquery name="qItems" dataSource="#Application.ExamplesDSN#">
SELECT CatAlias.strCatName, 
		ItemAlias.strItmName, 
		ItemAlias.dblItmCost,
		ItemAlias.strItmID
FROM tblStCat CatAlias, tblStItm ItemAlias
WHERE CatAlias.strCatID = ItemAlias.strCatIDFK

<cfif CategoryID NEQ "ALL">
AND ItemAlias.strCatIDFK = '#FORM.CategoryID#'
</cfif>

<cfif ItemName NEQ "">
AND ItemAlias.strItmName LIKE <cfqueryPARAM value="#FORM.ItemName#%" CFSQLType="CF_SQL_CHAR">
</cfif>

ORDER BY CatAlias.strCatName, ItemAlias.strItmName
</cfquery>

<p>
If the search returned any results, we present them here in summary form (the category, item name, and price).  
The summary is also hyperlinked to a detail page.  Click on the link to "drill-down" into the results.  
If there were more than 5 results, we allow the user to page through the results with a Prior/Next feature.
<p>

Your search found <cfoutput>#qItems.RecordCount#</cfoutput> items:<p>

<!---
	Only enter the next section if records were found...
--->
<cfif qItems.RecordCount NEQ 0>
	
	<!---
		The following implements Next/Prior-N type of browsing. 
		Given a maximum number of records to display on any given 
		page (DisplayCount variable), determine which record number 
		to begin with (FromRec)	and end with (ToRec).  
		The Number to end with (ToRec) should never be more than 
		the total number of records	found.
	--->
	<cfset DisplayCount=5>
	
	<cfif IsDefined("FromRec") IS "No">
		<!---
			Start with the first record unless none were found    
		--->
		<cfif qItems.RecordCount EQ 0>
			<cfset FromRec = 0>
		<cfelse>
			<cfset FromRec = 1>
		</cfif>
	
		<cfset ToRec = FromRec+(DisplayCount-1)>
	
		<cfif ToRec GT qItems.RecordCount>
		<!---
			This ToRec would be more than the total number of records,
			so use the total instead.          	
		--->
			<cfset ToRec = qItems.RecordCount>
		</cfif>	
	<cfelse>
		<cfset ToRec = FromRec+(DisplayCount-1)>
		<cfif ToRec GT qItems.RecordCount>
		<!--- 
			This ToRec would be more than the total
			number of records, so use the total instead. 
		--->
			<cfset ToRec = qItems.RecordCount>
		</cfif>
	</cfif>
	
	<p>
	<cfoutput>Displaying records #FromRec# through #ToRec# of #qItems.RecordCount#</cfoutput>
	<br>
	
	<p>
	<cfoutput query="qItems" startRow="#FromRec#" maxRows="#DisplayCount#">
	<a href="detail.cfm?ItemID=#strItmID#">
	#strCatName# - #strItmName# #DollarFormat(dblItmCost)#<br>
	</a>
	</cfoutput>
	
	<hr>
	<p>
	
	<!---
		Now for the prior/next links...
		The Prior group of records would have started "DisplayCount"
		records (in this case, 5) before the current start record.  
		The next group will start "DisplayCount" (again, 5) more 
		than the current start record.
	--->
	<cfset PreRec = FromRec-DisplayCount>
	<cfset NextRec = FromRec+DisplayCount>	
	
	<cfif PreRec GT 0>
		<!--- gt 0 indicates that this is NOT the first set of records --->
		<cfoutput>
		<!---
			Notice that we append the CategoryID and ItemName variables 
			to the URL.  These values came initially from the form post, 
			but we now need to pass them along via this method.
		--->	
		<a href="#cgi.script_name#?FromRec=#PreRec#&CategoryID=#CategoryID#&ItemName=#ItemName#">&lt;&lt; Prior</a></cfoutput>
	</cfif>
	&nbsp;&nbsp;
	<cfif NextRec LT qItems.RecordCount>
		<cfoutput><a href="#cgi.script_name#?FromRec=#NextRec#&CategoryID=#CategoryID#&ItemName=#ItemName#">Next &gt;&gt;</a></cfoutput>
	</cfif>
	<br><br>
</cfif>
<a href="index.cfm">search again</a>
<br><br>
<cfinclude template="../marginbottom.cfm">
<cfinclude template="../behindscenes.cfm">
<cfinclude template="../footer.cfm">

