<!--- Macromedia ColdFusion(r) 5.0 - Code Examples --->
<!--- Data Maintenance Example --->
<cfset pagename="Data Maintenance Example">
<cfinclude template="../header.cfm">
<cfinclude template="../behindscenes.cfm">
<cfinclude template="../margintop.cfm">

<p>
Insert, Update, and Delete; the basics of all data maintenance applications!  
This example will illustrate how to accomplish all three common functions from a single CFML page.
<p>
<hr>
<p>
<!---
	If the PAGEACTION parameter exists, that means that we were
	posted to this page from either the Update, Insert, or
	Delete page.  So take the disired action.
--->
<cfparam name="FORM.EmployeeID" default="">

<cfif IsDefined("PageAction")>
<cfswitch expression="#Form.PageAction#">
	<cfcase value="Insert">
		<!---
			PAGEACTION is insert - Add the new employee record.
		--->
		<cfset NewEmpID = CreateUUID()>
		
		<cfquery name="AddEmployee" dataSource="#Application.ExamplesDSN#">
		INSERT INTO tblEmp (strEmpID, strFname, strLname, strEmail, strPhone, glbPersnl)
		VALUES ('#NewEmpID#',
		<cfqueryparam value="#FirstName#" CFSQLType="CF_SQL_CHAR">,
		<cfqueryparam value="#LastName#" CFSQLType="CF_SQL_CHAR">,
		<cfqueryparam value="#Email#" CFSQLType="CF_SQL_CHAR">,
		<cfqueryparam value="#Phone#" CFSQLType="CF_SQL_CHAR">,
		<cfqueryparam value="#Comments#" CFSQLType="CF_SQL_LONGVARCHAR">
		)
		</cfquery>
		<font color="Green"><cfoutput>#FirstName# #LastName# has been added!</cfoutput></font><p>
	</cfcase>
		
	<cfcase value="Update">
		<cfif FORM.EmployeeID IS NOT "">
		<!---
			PAGEACTION is Update - Display the employee record in a
			form first.  Then, after the form is submitted, update the
			record.
		--->
		<cfif NOT IsDefined("submitted")>
		
			<cfquery name="TheEmployee" dataSource="#Application.ExamplesDSN#">
			SELECT strFname, strLname, strEmpID, strEmail, strPhone, glbPersnl 
			FROM   tblEmp 
			WHERE strEmpID = '#Form.EmployeeID#'
			</cfquery>
	
			<cfform action="#cgi.script_name#" method="Post" name="UpdateEmplForm">
			<input type="HIDDEN" name="PageAction" value="Update"> 
			<input type="HIDDEN" name="EmployeeID" value="<cfoutput>#Form.EmployeeID#</cfoutput>"> 
			<b class="text">Edit Employee</b>
			<br><br>
			<table>
			<tr>
				<td><p>Last Name</p></td>
				<td>
					<cfinput type="Text" 
						name="LastName" 
						value="#TheEmployee.strLname#" 
						message="Please enter your last name..." 
						required="Yes">
				</td>
			</tr>
			<tr>
				<td><p>First Name</p></td>
				<td>
					<cfinput type="Text" 
						name="FirstName" 
						value="#TheEmployee.strFname#" 
						message="Please enter your first name..." 
						required="Yes">
				</td>
			</tr>
			<tr>
				<td><p>Phone</p></td>
				<td><cfinput type="text" 
						name="phone" 
						value="#TheEmployee.strPhone#"></td>
			</tr>
			<tr>
				<td><p>Email</p></td>
				<td><cfinput type="text" 
						name="email" 
						value="#TheEmployee.strEmail#"></td>
			</tr>
			<tr>
				<td><p>Comments</p></td>
				<td>
					<textarea cols="30" rows="3" 
						name="Comments" wrap="virtual"><cfoutput>#TheEmployee.glbPersnl#</cfoutput></textarea>
				</td>
			</tr>
			</table>
			<p>
			<input type="submit" value="Update Employee" name="submitted"> 
			<input type="reset" value="Reset Form"> <input type="button" value="Cancel" onClick="javascript:document.location='index.cfm';">
			</cfform> 
			<hr>
			<p>
		<cfelse>
		
			<cfquery name="UpdateEmployee" dataSource="#Application.ExamplesDSN#">
			UPDATE tblEmp
			SET strFname = <cfqueryparam value="#FirstName#" CFSQLType="CF_SQL_CHAR">, 
				strLname = <cfqueryparam value="#LastName#" CFSQLType="CF_SQL_CHAR">, 
				strEmail = <cfqueryparam value="#Email#" CFSQLType="CF_SQL_CHAR">, 
				strPhone = <cfqueryparam value="#Phone#" CFSQLType="CF_SQL_CHAR">,
				glbPersnl = <cfqueryparam value="#Comments#" CFSQLType="CF_SQL_LONGVARCHAR">
			WHERE strEmpID = '#Form.EmployeeId#' 
			</cfquery>
		
			<font color="Green"><cfoutput>#Form.FirstName# #Form.LastName# has been updated!</cfoutput></font><p>
			<hr>
			<p>
		</cfif>
		</cfif>
	</cfcase>
	
	<cfcase value="Delete">
		<cfif FORM.EmployeeID IS NOT "">
			<!---
				PAGEACTION is Delete - remove the employee record.
			--->
			<cfquery name="DeleteEmployee" dataSource="#Application.ExamplesDSN#">
			DELETE FROM tblEmp
			WHERE strEmpID = '#Form.EmployeeId#'
			</cfquery>
			
			<font color="Green">Employee has been deleted!</font><p>
		</cfif>
	</cfcase>
</cfswitch>
</cfif>

<b>Current Employees</b> (click on a name and then select either 'edit' or 'delete')
<br><br>

<cfquery name="AllEmployees" dataSource="#Application.ExamplesDSN#">
SELECT strFname, strLname, strEmpID
FROM   tblEmp 
ORDER BY  strLname, strFname
</cfquery>

<form action="<cfoutput>#cgi.script_name#</cfoutput>" method="post" name="CurrentEmplForm">

<select name="EmployeeID" size="10">
<cfoutput query="AllEmployees">
<option value="#strEmpID#">#strFname# #strLname#
</cfoutput>
</select>
<br><br>
<input type="Button" value="    Edit...    " 
	onClick="Javascript:document.CurrentEmplForm.PageAction.value='Update';document.CurrentEmplForm.submit();"> 
<input type="Button" value="   Delete...   " 
	onClick="Javascript:document.CurrentEmplForm.PageAction.value='Delete';document.CurrentEmplForm.submit();">
<input type="hidden" name="PageAction"> 
</form>
 
<hr> 
<cfform action="#cgi.script_name#" method="Post" name="NewEmplForm">
<input type="HIDDEN" name="PageAction" value="Insert"> 
<p>
<b>Add New Employee</b>
<br><br>
 
 
<table>
<tr>
	<td><p>Last Name</p></td>
	<td><cfinput type="Text" name="LastName" message="Please enter your last name..." required="Yes"></td>
</tr>
<tr>
	<td><p>First Name</p></td>
	<td><cfinput type="Text" name="FirstName" message="Please enter your first name..." required="Yes"></td>
</tr>
<tr>
	<td><p>Phone</p></td>
	<td><cfinput type="text" name="phone"></td>
</tr>
<tr>
	<td><p>Email</p></td>
	<td><cfinput type="text" name="email"></td>
</tr>
<tr>
	<td><p>Comments</p></td>
	<td><textarea cols="30" rows="3" name="Comments" wrap="virtual"></textarea></td>
</tr>
</table>

<p>
<input type="submit" value="  Add Employee  "> 
<input type="reset" value="Clear Form"> 
</cfform> 
<cfinclude template="../marginbottom.cfm">
<cfinclude template="../behindscenes.cfm">
<cfinclude template="../footer.cfm">

