<cfinclude template="../include1.html">
Graphing Example
<cfinclude template="../include2.html">


<!--- Set graph defaults --->
<cfparam name="width" default="350">
<cfparam name="height" default="300">
<cfparam name="Form.depth" default="15">
<cfparam name="Form.borderwidth" default="1">
<cfparam name="Form.bordercolor" default="black">
<cfparam name="Form.bgcolor" default="white">
<cfparam name="Form.scaleto" default="20000">
<cfparam name="Form.scalefrom" default="0">
<cfparam name="Form.linewidth" default="2">
<cfparam name="Form.gridlines" default="4">
<cfparam name="Form.linecolor" default="red">
<cfparam name="Form.colorlist" default="##99cc99,##6666cc,##336699,##666666">
<cfparam name="Form.barspacing" default="15">

<!--- check to see if the form below was submitted --->
<cfif IsDefined("form.submit")>
	
	<!--- Include the page which creates the query results --->
	<cfinclude template="data.cfm">

	<!--- Query the sls_data query based on the form selections --->
  	<cfquery name="get_total_sales" dbtype="query">
		SELECT slsQuarter,slsAmount
		FROM sls_data
		WHERE slsYear = #Form.year#
		AND slsProdcat = '#Form.prod_category#'
		ORDER BY slsQuarter
	</cfquery>
<cfelse>
	<cflocation url="index.cfm" addtoken="No">  
</cfif>

<table width="644" cellspacing="0" cellpadding="0" border="0">
	<tr>
		<td width="485" valign="top" colspan="2">
			<table width="100%" border="0">
				<tr>							
					<td>
						<table border="0" cellpadding="6">							
								<cfform action="build_graph2.cfm" method="POST" preservedata="yes">										
									<!------------------------------------------------------------------------------
									Build proper graph based on the graph type selected, using cfswitch we can 
									execute the corresponding cfcase statement below based on the value passed 
									into the switch.	
									------------------------------------------------------------------------------->
									<cfswitch expression="#Form.graph_type#">
										
										<cfcase value="line">
											<tr>
												<td colspan="2">
												<cfgraph type = "line"
												  query = "get_total_sales"
												  valueColumn = "slsAmount"
												  itemColumn = "slsQuarter"
												  scaleFrom = #Form.scalefrom#
												  scaleTo = #Form.scaleto#
												  showItemLabel = "yes"
												  itemLabelFont = "Arial"
												  itemLabelSize = 12
												  itemLabelOrientation = "horizontal"
												  title = "#Form.prod_category# Sales for #Form.Year#"
												  titleFont = "Arial"
												  fileFormat = "gif"
												  lineColor = "#Form.linecolor#"
												  lineWidth = #Form.linewidth#
												  fill = "no"
												  graphHeight = #height#
												  graphWidth = #width#
												  backgroundColor = "#Form.bgcolor#"
												  borderColor = "#Form.bordercolor#"
												  borderWidth = #Form.borderwidth#
												  depth = #Form.depth#
												  gridLines = #Form.gridlines#>											
												</cfgraph> 
												</td>
											</tr>																	
											<tr>
												<td>
												Line width:
												</td>
												<!--- Form control for line width --->	
												<td>
												<cfinput name="linewidth" value="Form.linewidth" required="Yes" message="You must provide a Line Width" size="3" maxlength="1">
												</td>
											</tr>
											<tr>
												<td>
												Gridlines:
												</td>
												<!--- Form control for gridlines --->
												<td>
												<cfinput name="gridlines" value="Form.gridlines" required="Yes" message="You must provide a value for Grid Lines" size="3" maxlength="1">
												</td>
											</tr>												
										</cfcase>										
										
										<cfcase value="bar">
											<tr>
												<td colspan="2">
												<cfgraph type = "bar"
												  query = "get_total_sales"
												  valueColumn = "slsAmount"
												  itemColumn = "slsQuarter"
												  showValueLabel = "rollover"
												  valueLabelFont = "Arial"
												  valueLabelSize = "10"
												  valueLocation = "overbar"
												  scaleFrom = #Form.scalefrom#
												  scaleTo = #Form.scaleto#
												  showItemLabel = "yes"
												  itemLabelFont = "Arial"
												  itemLabelSize = "10"
												  itemLabelOrientation = "horizontal"
												  title = "#Form.prod_category# Sales for #Form.Year#"
												  titleFont = "Arial"
												  fileFormat = "gif"
												  barSpacing = #Form.barspacing# 
												  graphHeight = #height#
												  graphWidth = #width#
												  backgroundColor = "#Form.bgcolor#"
												  borderColor = "#Form.bordercolor#"
												  borderWidth = #Form.borderwidth#
												  depth = #Form.depth#
												  colorList = "#Form.colorlist#"
												  gridLines = #Form.gridlines#>											 
												</cfgraph> 
												</td>
											</tr>		
										
											<tr>
												<td>
												Bar spacing:
												</td>
												<!--- Form control for Bar Spacing --->	
												<td>
												<cfinput name="barspacing" value="Form.barspacing" required="Yes" message="You must provide a value for Bar Spacing" size="2" maxlength="2">
												</td>
											</tr>
											<tr>
												<td>
												Gridlines:
												</td>
												<!--- Form control for gridlines --->
												<td>
												<cfinput name="gridlines" value="Form.gridlines" required="Yes" message="You must provide a value for Grid Lines" size="1" maxlength="1">
												</td>
											</tr>																				
										</cfcase>	
																				
										<cfcase value="pie">
											<tr>
												<td colspan="2">
												<cfgraph type = "pie"
												  query = "get_total_sales"
												  valueColumn = "slsAmount"
												  itemColumn = "slsQuarter"
												  valueLabelFont = "Arial"
												  valueLabelSize = "10"
												  valueLocation = "outside"
												  title = "#Form.prod_category# Sales for #Form.Year#"
												  titleFont = "Arial"
												  fileFormat = "gif"
												  backgroundColor = "#Form.bgcolor#"
												  borderColor = "#Form.bordercolor#"
												  borderWidth = #Form.borderwidth#
												  graphHeight = #height#
												  graphWidth = #width#
												  depth = #Form.depth#
												  colorList = "#Form.colorlist#"
												  showLegend = "right">											 
												</cfgraph>	
												</td>	
											</tr>								 
										</cfcase>											
									</cfswitch>
									<!--- Display these controls as long as the graph type is not "pie"	 --->									
									<cfif graph_type IS NOT "pie">
											
											<tr>
												<td>Scale from:</td>
												<!--- Form control for Scaling From --->
												<td>
												<cfinput name="scalefrom" value="Form.scalefrom" required="Yes" message="You must provide a value for Scale From" size="5" maxlength="5">
												</td>
											</tr>
											<tr>
												<td>Scale to:</td>
												<!--- Form control for Scale To --->
												<td>
												<cfinput name="scaleto" value="Form.scaleto" required="Yes" message="You must provide a value for Scale To" size="5" maxlength="5">
												</td>
											</tr>																
									</cfif>	
									
									<cfif graph_type IS NOT "line">
										
											<tr>
												<td>Item colors:</td>
												<td>
													<table border="0" cellspacing="6">
														<tr>
															<td><input type="Checkbox" name="colorlist" value="#99cc99" <cfif Form.colorlist CONTAINS "99cc99">checked</cfif>></td><td bgcolor="#99cc99">&nbsp;&nbsp;&nbsp;</td>
															<td><input type="Checkbox" name="colorlist" value="#6666cc" <cfif Form.colorlist CONTAINS "6666cc">checked</cfif>></td><td bgcolor="#6666cc">&nbsp;&nbsp;&nbsp;</td>
															<td><input type="Checkbox" name="colorlist" value="#ff9966" <cfif Form.colorlist CONTAINS "ff9966">checked</cfif>></td><td bgcolor="#ff9966">&nbsp;&nbsp;&nbsp;</td>
														</tr>
														<tr>
															<td><input type="Checkbox" name="colorlist" value="#009966" <cfif Form.colorlist CONTAINS "009966">checked</cfif>></td><td bgcolor="#ffff99">&nbsp;&nbsp;&nbsp;</td>
															<td><input type="Checkbox" name="colorlist" value="#336699" <cfif Form.colorlist CONTAINS "336699">checked</cfif>></td><td bgcolor="#336699">&nbsp;&nbsp;&nbsp;</td>
															<td><input type="Checkbox" name="colorlist" value="#ffcc66" <cfif Form.colorlist CONTAINS "ffcc66">checked</cfif>></td><td bgcolor="#ffcc66">&nbsp;&nbsp;&nbsp;</td>
														</tr>
														<tr>
															<td><input type="Checkbox" name="colorlist" value="#99ff99" <cfif Form.colorlist CONTAINS "99ff99">checked</cfif>></td><td bgcolor="#99ff99">&nbsp;&nbsp;&nbsp;</td>
															<td><input type="Checkbox" name="colorlist" value="#666666" <cfif Form.colorlist CONTAINS "666666">checked</cfif>></td><td bgcolor="#666666">&nbsp;&nbsp;&nbsp;</td>
															<td><input type="Checkbox" name="colorlist" value="#ff3333" <cfif Form.colorlist CONTAINS "ff3333">checked</cfif>></td><td bgcolor="#ff3333">&nbsp;&nbsp;&nbsp;</td>
														</tr>
													</table>
													
												</td>
											</tr>
									</cfif>
																		
											<tr>
												<td>Border width:</td>
												<!--- Form control for Border Width --->
												<td>
												<cfinput name="borderwidth" value="Form.borderwidth" required="Yes" message="You must provide a value for Border Width" size="1" maxlength="1">
												</td>
											</tr>
											<tr>
												<td>Depth:</td>
												<!--- Form control for Depth --->
												<td>
											  	<cfslider name="depth"
													value="15"
													label="Depth: "
													range="1,50"
													align="BASELINE"
													message="Slide the bar to get a value between 100 and 800"
													height="50"
													width="150"
													font="Verdana"
													bgColor="White"
													grooveColor="Lime"
													bold="No"
													italic="No"
													refreshLabel="Yes"> 											
												</td>
											</tr>
											<!--- Drop-down for selecting graph type --->
											<tr>
												<td>Change Graph Type:</td>
												<td>
												<cfselect name="graph_type">
													<option value="">Select graph type
													<option value="bar" <cfif Form.graph_type IS "bar">selected</cfif>>bar
													<option value="line" <cfif Form.graph_type IS "line">selected</cfif>>line
													<option value="pie" <cfif Form.graph_type IS "pie">selected</cfif>>pie
												</cfselect>
												</td>
											</tr>
											<!--- Drop-down for selecting background color --->
											<tr>
												<td>Background Color:</td>
												<td>												
													<table border="0" cellspacing="6">
														<tr>
															<td><input type="radio" name="bgcolor" value="white" <cfif Form.bgcolor CONTAINS "white">checked</cfif>></td><td bgcolor="white">&nbsp;&nbsp;&nbsp;</td>
															<td><input type="radio" name="bgcolor" value="silver" <cfif Form.bgcolor CONTAINS "silver">checked</cfif>></td><td bgcolor="silver">&nbsp;&nbsp;&nbsp;</td>
															<td><input type="radio" name="bgcolor" value="#cccc99" <cfif Form.bgcolor CONTAINS "cccc99">checked</cfif>></td><td bgcolor="#cccc99">&nbsp;&nbsp;&nbsp;</td>
														</tr>
													</table>																		
												</td>
											</tr>
											<!--- Drop-down for selecting border color --->
											<tr>
												<td>Border Color:</td>
												<td>												
													<table border="0" cellspacing="6">
														<tr>
															<td><input type="radio" name="bordercolor" value="black" <cfif Form.bordercolor CONTAINS "black">checked</cfif>></td><td bgcolor="black">&nbsp;&nbsp;&nbsp;</td>
															<td><input type="radio" name="bordercolor" value="#666666" <cfif Form.bordercolor CONTAINS "666666">checked</cfif>></td><td bgcolor="#666666">&nbsp;&nbsp;&nbsp;</td>
															<td><input type="radio" name="bordercolor" value="#ff3300" <cfif Form.bordercolor CONTAINS "ff3300">checked</cfif>></td><td bgcolor="#ff3300">&nbsp;&nbsp;&nbsp;</td>
														</tr>
													</table>																		
												</td>
											</tr>
									<!--- Only display this control if graph_type is "line" --->
									<cfif graph_type IS "line">
											<tr>
												<td>Change Line Color:</td>
												<td>
												<cfselect name="linecolor">
													<option value="">Select line color
													<option value="red" <cfif Form.linecolor IS "red">selected</cfif>>red
													<option value="blue" <cfif Form.linecolor IS "blue">selected</cfif>>blue
													<option value="green" <cfif Form.linecolor IS "green">selected</cfif>>green
												</cfselect>
												</td>
											</tr>
									</cfif>
											<tr>
												<td>
												<input type="Hidden" name="prod_category" value="<cfoutput>#Form.prod_category#</cfoutput>">
												<input type="Hidden" name="year" value="<cfoutput>#Form.year#</cfoutput>">
												</td>
											</tr>
											<tr>
												<td colspan="2" align="center"><input type="Submit" name="submit" value="Apply Changes"></td>
											</tr>
										</table>								
									</cfform>						
								</td>
							</tr>
						</table>	
					</td>						
				</tr>
			</table>
		</td>
	</tr>
</table>

<br><br>
<cfinclude template="../include3.html">
