<!--- Macromedia ColdFusion(r) 5.0 - Code Examples ---> 
<!--- CFGRAPH Example --->
<cfset pagename="CFGRAPH Example">
<cfinclude template="../header.cfm">
<cfinclude template="../behindscenes.cfm">
<cfinclude template="../margintop.cfm">

<p>
This page shows four different graphs produced from the same database query with the new cfgraph tag.
<p>
Right-click on one of the graphs and select zoom in.  Zooming, useful for large graphs with many data points, is just one of the benefits of using Macromedia Flash as the file format for the graphs. 
</p>
<p>
Below the graphs, the new cfdump tag is used to output a formatted view of the data used for the graphs.  cfdump may be used to display any data; simple variables, query result sets, arrays, structures, etc.
</p>
<!--- Set graph defaults --->
<cfparam name="width" default="350">
<cfparam name="height" default="300">

<!--- Get graphing data --->
<cfquery name="get_depts" dataSource="cfsnippets">
	SELECT Department, COUNT(*) AS count
	FROM Employees
	GROUP BY Department
</cfquery>

<table width="644" cellspacing="0" cellpadding="0" border="0">
	<tr>
		<td valign="top">
		<!--- Build a bar graph using the queried data --->
			<cfgraph type = "bar"
				 query = "get_depts"
				 valueColumn = "count"
				 itemColumn = "Department"
				 title = "Number of Employees by Department"
				 scaleFrom = "0"
				 scaleTo = "10"
				 depth = "15"
				 barSpacing = "15"
				 gridLines = "4"
				 graphHeight = "#height#"
				 graphWidth = "#width#"
				 colorList = "##003399,##99ccff,##339900,##660066"
				 itemLabelOrientation = "horizontal"
				 valueLocation = "overbar"
				 >
															 
			</cfgraph> 	
		</td>
		<td valign="top">
		<!--- Build a pie chat using the queried data --->
			<cfgraph type = "pie"
				 query = "get_depts"
				 valueColumn = "count"
				 itemColumn = "Department"
				 title = "Number of Employees by Department"
				 valueLocation = "outside"
				 borderWidth = "0"
				 graphHeight = "#height#"
				 graphWidth = "#width#"
				 depth = "15"
				 colorList = "##003399,##99ccff,##339900,##660066"
				 showLegend = "right">
			
			<!--- Here is a hardcoded value to graph along with the 
					query data.  --->	 		
			<cfgraphdata item="HR" value="6" color="##99cc99">									 
			
			</cfgraph>	
		</td>
	</tr>
	<tr>
		<td valign="top">
		<!--- Build a line graph using the queried data --->
			<cfgraph type = "line"
				 query = "get_depts"
				 valueColumn = "count"
				 itemColumn = "Department"
				 scaleFrom = "0"
				 scaleTo = "10"
				 title = "Number of Employees by Department"			 
				 graphHeight = "#height#"
				 graphWidth = "#width#"
				 depth = "10"
				 gridLines = "4">											
			</cfgraph>
		
		</td>
		<td valign="top">
		<!--- Build a horizontal bar graph using the queried data --->
			<cfgraph type = "horizontalbar"
				 query = "get_depts"
				 valueColumn = "count"
				 itemColumn = "Department"
				 valueLocation = "overbar"
				 scaleFrom = "0"
				 scaleTo = "10"
				 title = "Number of Employees by Department"
				 barSpacing = "15" 
				 graphHeight = "#height#"
				 graphWidth = "#width#"
				 depth = "15"
				 colorList = "##003399,##99ccff,##339900,##660066,##ff99ff,##cc0000"
				 gridLines = "4">											 
			</cfgraph>
		</td>
	</tr>
</table><br><br>
<font face="Arial"><font size="-1">The query data for the graphs is shown here:<br><br>
<cfdump var="#get_depts#">	</font></font>
<br><br>
<cfinclude template="../marginbottom.cfm">
<cfinclude template="../behindscenes.cfm">
<cfinclude template="../footer.cfm">

