<!--- Macromedia ColdFusion(r) 5.0 - Code Examples --->
<!--- Mailing List Union Example --->
<cfset pagename="Query of Query Example">
<cfinclude template="../header.cfm">
<cfinclude template="../behindscenes.cfm">
<cfinclude template="../margintop.cfm">
<p>
<b>Query of Query Example</b>

<p>
This simple page would seem to require multiple round-trips to the database every time it is viewed.  There is a query required to populate the drop-down, and another to select the specified parks.  Certainly caching the query that populates the drop-down would be helpful in boosting performance.  But caching would not help with the other query as the criteria is always changing to a different state.  
<p>
With ColdFusion's new Query of Queries feature, however, all data on the page can be acquired from a single cached query, dramatically improving page processing time and reducing network traffic to the database server. 
<p>
<!--- Set default form value --->
<cfparam name="Form.state" default="">

<!--- Query the database for all parks and cache it --->
<cfquery name="get_parks" dataSource="cfsnippets" DBType="ODBC" cachedWithin="#CreateTimeSpan(1,  4,  0,  0)#">
	SELECT ParkName, City, State, Region, ParkType
	FROM Parks
</cfquery>

<!--- Query the "get_parks" query for a list of states that can be used in the pull-down filter --->
<cfquery name="get_states_qofq" DBType="query">
	SELECT DISTINCT state
	FROM get_parks
	WHERE state <> ''
	ORDER BY state
</cfquery>

<table width="85%" bgcolor="#999999" border="0" cellpadding="0" cellspacing="0">
<tr>
	<td><table width="100%" border="0" cellpadding="2" cellspacing="1">
	<!--- This is the state selection form, it submits the form to itself (index.cfm) --->
	<form action="index.cfm" method="post">
	<tr>
		<td colspan="5" bgcolor="white"><p>
			Show parks in &nbsp;&nbsp;

			<select name="state">
				<option value="">Select a state
			<!--- Build the state select box using the list of states retrieved from the query of query --->
			<cfoutput query="get_states_qofq">
				<option value="#state#" <cfif state IS "#Form.state#">selected</cfif>>#state#
			</cfoutput>
			</select> &nbsp;&nbsp;

			<input type="submit" name="submit" value="Get Parks"></p>
		</td>
	</tr>
	</form>
<!--- Display the results after a state is selected --->
<cfif IsDefined("Form.submit") AND IsDefined("Form.state") AND Len(Form.state) GT 0>

<!--- Query the "get_parks" query for parks from selected state --->
<cfquery name="get_parks_qofq" DBType="query">
	SELECT *
	FROM get_parks
	WHERE state = '#Form.state#'
</cfquery>

		<tr>
			<td bgcolor="white"><p><b>Park Name</b></p></td>
			<td bgcolor="white"><p><b>City</b></p></td>
			<td bgcolor="white"><p><b>State</b></p></td>
			<td bgcolor="white"><p><b>Region</b></p></td>
			<td bgcolor="white"><p><b>Park Type</b></p></td>
		</tr>
	<cfoutput query="get_parks_qofq">
		<tr>
			<td valign="top" bgcolor="white"><p>#ParkName#</p></td>
			<td valign="top" bgcolor="white"><p>#City#</p></td>
			<td valign="top" bgcolor="white" align="center"><p>#UCase(State)#</p></td>
			<td valign="top" bgcolor="white"><p>#UCase(Region)#</p></td>
			<td valign="top" bgcolor="white"><p>#UCase(ParkType)#</p></td>
		</tr>
	</cfoutput>
</cfif>
</table></td>
</tr>
</table>
<br><br>
<cfinclude template="../marginbottom.cfm">
<cfinclude template="../behindscenes.cfm">
<cfinclude template="../footer.cfm">
