<!--- Macromedia ColdFusion(r) 5.0 - Code Examples --->
<!--- User Defined Functions Example --->
<cfset pagename="Temperature Conversion UDF Example">
<cfinclude template="../header.cfm">
<cfinclude template="../behindscenes.cfm">
<cfinclude template="../margintop.cfm">

<p>
This example will introduce the basics of <b>User Defined Functions (UDF)</b>.
<p>
Enter a temperature and select its scale (i.e. 50 degrees Fahrenheit).  Click 'Convert Temperature' 
to submit the form and use a UDF to convert it to the other scale.
<p>

<!---
	The UDF is defined in this block of CFSCRIPT.
	Two arguments are passed to the function, a temperature and 
	the scale that it is in.  The temperature is checked to 
	make sure it's a number (the value "NAN" is returned and 
	processing ends if it is not).  Then the calculation is 
	processed based on the scale being "F" or "C."   If the 
	scale given is neither "F" nor "C," the message "Not a 
	valid scale" is returned.
--->	

<cfparam name="FORM.ScaleFrom" default="">

<cfscript>
function TempConvert(ATemp, ItsScale){
if (not IsNumeric(ATemp)) return "NAN";

if (UCase(ItsScale) eq "F")
	// temp given in Fahrenheit.  Convert to Celsius
	degs = (ATemp - 32.0) * (5.0/9.0);
else if (UCase(ItsScale) eq "C")	
	// temp given in Celsius.  Convert to Fahrenheit
	degs = (ATemp * 9.0/5.0) + 32;
else
	degs = "Not a valid Scale";
;
return degs;
}
</cfscript>

<!---
	Based on the Scale abbreviation, set the display name of
	the 'To' and 'From' scales.
--->	
<cfif IsDefined("Form.Temp")>
<cfif Form.ScaleFrom eq "F">
	<cfset scaleFromName = "Fahrenheit">
	<cfset scaleToName = "Celsius">
<cfelse>
	<cfset scaleFromName = "Celsius">
	<cfset scaleToName = "Fahrenheit">
</cfif>

<cfoutput>
	#Form.Temp# degrees #ScaleFromName# = #TempConvert(Form.Temp, Form.ScaleFrom)# degrees #ScaleToName#
</cfoutput>
</cfif>

<!---
	The new preserveData attribute will show the temperature in
	its text box after the form has been posted.
--->	
<cfform action="#cgi.script_name#"
        method="POST"
        enableCAB="Yes"
        preserveData="Yes">

<span class="text">Convert Temperature from</span> <cfinput type="Text" name="Temp" required="Yes"> <span class="text">degrees</span><br>
<br>
<table>
<tr><td colspan="2"><p>Scale:</p></td></tr>
<tr>
	<td><p>Fahrenheit</p></td>
	<td><cfinput type="radio" name="scaleFrom" value="F" checked></td>
</tr>
<tr>
	<td><p>Celsius</p></td>
	<td><cfinput type="radio" name="scaleFrom" value="C"></td>
</tr>
</table>

<input type="submit" name="submit" value="Convert Temperature">

</cfform>

<br><br>
<cfinclude template="../marginbottom.cfm">
<cfinclude template="../behindscenes.cfm">
<cfinclude template="../footer.cfm">
